
;CodeVisionAVR C Compiler V1.25.7 beta 5 Professional
;(C) Copyright 1998-2007 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type              : ATmega8
;Program type           : Application
;Clock frequency        : 16,000000 MHz
;Memory model           : Small
;Optimize for           : Size
;(s)printf features     : int, width
;(s)scanf features      : int, width
;External SRAM size     : 0
;Data Stack size        : 256 byte(s)
;Heap size              : 0 byte(s)
;Promote char to int    : No
;char is unsigned       : Yes
;8 bit enums            : Yes
;Word align FLASH struct: No
;Enhanced core instructions    : On
;Smart register allocation : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega8
	#pragma AVRPART MEMORY PROG_FLASH 8192
	#pragma AVRPART MEMORY EEPROM 512
	#pragma AVRPART MEMORY INT_SRAM SIZE 1024
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ANDI R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ORI  R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	LDI  R30,0
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	LDI  R22,BYTE3(2*@0+@1)
	LDI  R23,BYTE4(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+@2)
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+@3)
	LDI  R@1,HIGH(@2+@3)
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+@3)
	LDI  R@1,HIGH(@2*2+@3)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+@2
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+@3
	LDS  R@1,@2+@3+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+@1,R0
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	RCALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	RCALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	RCALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

	.CSEG
	.ORG 0

	.INCLUDE "fibo3.vec"
	.INCLUDE "fibo3.inc"

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,13
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x400)
	LDI  R25,HIGH(0x400)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x45F)
	OUT  SPL,R30
	LDI  R30,HIGH(0x45F)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x160)
	LDI  R29,HIGH(0x160)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x160
;       1 /*****************************************************
;       2 This program was produced by the
;       3 CodeWizardAVR V1.25.7 beta 5 Professional
;       4 Automatic Program Generator
;       5  Copyright 1998-2007 Pavel Haiduc, HP InfoTech s.r.l.
;       6 http://www.hpinfotech.com
;       7 
;       8 Project :
;       9 Version :
;      10 Date    : 02.03.2008
;      11 Author  : Spiritus Sancti
;      12 Company : licrym.org
;      13 Comments: CC BY-NC-SA
;      14 
;      15 
;      16 Chip type           : ATmega8
;      17 Program type        : Application
;      18 Clock frequency     : 16,000000 MHz
;      19 Memory model        : Small
;      20 External SRAM size  : 0
;      21 Data Stack size     : 256
;      22 *****************************************************/
;      23 
;      24 #include <mega8.h>
;      25 	#ifndef __SLEEP_DEFINED__
	#ifndef __SLEEP_DEFINED__
;      26 	#define __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
;      27 	.EQU __se_bit=0x80
	.EQU __se_bit=0x80
;      28 	.EQU __sm_mask=0x70
	.EQU __sm_mask=0x70
;      29 	.EQU __sm_powerdown=0x20
	.EQU __sm_powerdown=0x20
;      30 	.EQU __sm_powersave=0x30
	.EQU __sm_powersave=0x30
;      31 	.EQU __sm_standby=0x60
	.EQU __sm_standby=0x60
;      32 	.EQU __sm_ext_standby=0x70
	.EQU __sm_ext_standby=0x70
;      33 	.EQU __sm_adc_noise_red=0x10
	.EQU __sm_adc_noise_red=0x10
;      34 	.SET power_ctrl_reg=mcucr
	.SET power_ctrl_reg=mcucr
;      35 	#endif
	#endif
;      36 #include <stdlib.h>
;      37 #include <delay.h>
;      38 
;      39 #define ADC_VREF_TYPE 0x40
;      40 
;      41 #define gTimeOfMove 976       //     (1 )
;      42 #define StepsOfRecover 4      // ,    
;      43 
;      44 
;      45 
;      46 
;      47 unsigned int gtime;
;      48 bit ADC_complete;
;      49 unsigned char sensor_state, sensor_state_last;     //  ,      
;      50 unsigned int gADC_result;
;      51 unsigned char now, h;
;      52 // 
;      53 //
;      54 //      1   0   2
;      55 //        \ | /
;      56 //         [ ]
;      57 //        / | \
;      58 //       3  4  5
;      59 
;      60 const unsigned char gporog[6]={30, 30, 30, 30, 30, 30};       //    

	.CSEG
;      61                                                                     //    30     /-50
;      62                                                                     //const unsigned char gporog[6]={50, 100, 100, 150, 75, 150};
;      63 unsigned char d[7][7]={  //  ,  -  ,  - .

	.DSEG
_d:
;      64 //          STO    F   FR    FL    B   BR   BL
;      65 /*STO*/     {10,  15,  15,   15,  15,  15,  15},
;      66 /*F  */     {17,  23,  25,   25,   0,   0,   0},
;      67 /*FR */     {17,  23,  25,   25,   0,   0,   0},
;      68 /*FL */     {17,  33,  25,   25,   0,   0,   0},
;      69 /*B  */     {25,   0,   0,    0,  25,  25,  25},
;      70 /*BR */     {25,   0,   0,    0,  25,  25,  25},
;      71 /*BL */     {25,   0,   0,    0,  25,  25,  25}
;      72 };
	.BYTE 0x31
;      73 
;      74 const unsigned char etalon[7][7]={  //  ,     

	.CSEG
;      75 //          STO    F   FR    FL    B   BR   BL
;      76 /*STO*/     {10,  15,  15,   15,  15,  15,  15},
;      77 /*F  */     {17,  23,  25,   25,   0,   0,   0},
;      78 /*FR */     {17,  23,  25,   25,   0,   0,   0},
;      79 /*FL */     {17,  33,  25,   25,   0,   0,   0},
;      80 /*B  */     {25,   0,   0,    0,  25,  25,  25},
;      81 /*BR */     {25,   0,   0,    0,  25,  25,  25},
;      82 /*BL */     {25,   0,   0,    0,  25,  25,  25}
;      83 };
;      84 
;      85 
;      86 
;      87 interrupt [TIM1_COMPA] void timer1_compa_isr(void)  //     1/976 
;      88 {
_timer1_compa_isr:
	ST   -Y,R0
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
;      89   if (gtime!=0) --gtime;
	MOV  R0,R4
	OR   R0,R5
	BREQ _0x4
	MOVW R30,R4
	SBIW R30,1
	MOVW R4,R30
;      90 }
_0x4:
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R0,Y+
	RETI
;      91 
;      92 void delay (unsigned int time)                      //   ,  65535
;      93 {
_delay:
;      94   gtime=time;
;	time -> Y+0
	__GETWRS 4,5,0
;      95   while(gtime!=0){};
_0x5:
	MOV  R0,R4
	OR   R0,R5
	BRNE _0x5
;      96 }
	RJMP _0x76
;      97 
;      98 
;      99 
;     100 // ADC interrupt service routine
;     101 interrupt [ADC_INT] void adc_isr(void)              //   
;     102 {
_adc_isr:
	ST   -Y,R30
	IN   R30,SREG
;     103   unsigned int adc_data;
;     104   // Read the AD conversion result
;     105   adc_data=ADCW;
	RCALL __SAVELOCR2
;	adc_data -> R16,R17
	__INWR 16,17,4
;     106   gADC_result=adc_data;
	MOVW R8,R16
;     107   ADC_complete=1;
	SET
	BLD  R2,0
;     108 }
	RCALL __LOADLOCR2P
	OUT  SREG,R30
	LD   R30,Y+
	RETI
;     109 
;     110 int poll_sensor(unsigned char SensorNumber)         //  
;     111 {
_poll_sensor:
;     112   int delta, result1, result2;
;     113   ADMUX&=0b11110000;                                //     
	RCALL __SAVELOCR6
;	SensorNumber -> Y+6
;	delta -> R16,R17
;	result1 -> R18,R19
;	result2 -> R20,R21
	IN   R30,0x7
	ANDI R30,LOW(0xF0)
	OUT  0x7,R30
;     114   switch(SensorNumber)                              //  
	LDD  R30,Y+6
;     115   {
;     116      case 0:
	CPI  R30,0
	BREQ _0x78
;     117         ADMUX|=0b00000000;
;     118         break;
;     119      case 1:
	CPI  R30,LOW(0x1)
	BRNE _0xC
;     120         ADMUX|=0b00000001;
	SBI  0x7,0
;     121         break;
	RJMP _0xA
;     122      case 2:
_0xC:
	CPI  R30,LOW(0x2)
	BRNE _0xD
;     123         ADMUX|=0b00000010;
	SBI  0x7,1
;     124         break;
	RJMP _0xA
;     125      case 3:
_0xD:
	CPI  R30,LOW(0x3)
	BRNE _0xE
;     126         ADMUX|=0b00000011;
	IN   R30,0x7
	ORI  R30,LOW(0x3)
	RJMP _0x79
;     127         break;
;     128      case 4:
_0xE:
	CPI  R30,LOW(0x4)
	BRNE _0xF
;     129         ADMUX|=0b00000100;
	SBI  0x7,2
;     130         break;
	RJMP _0xA
;     131      case 5:
_0xF:
	CPI  R30,LOW(0x5)
	BRNE _0x11
;     132         ADMUX|=0b00000101;
	IN   R30,0x7
	ORI  R30,LOW(0x5)
	RJMP _0x79
;     133         break;
;     134      default:
_0x11:
;     135         ADMUX|=0b00000000;
_0x78:
	IN   R30,0x7
_0x79:
	OUT  0x7,R30
;     136         break;
;     137   };
_0xA:
;     138   PORTD|=1<<5;                                      //  5   D
	SBI  0x12,5
;     139   delay_us(50);                                     // 50    
	__DELAY_USW 200
;     140   ADCSRA|=0x40;                                     //    
	SBI  0x6,6
;     141   while(ADC_complete!=1);                           //    ,  
_0x12:
	SBRS R2,0
	RJMP _0x12
;     142   result1=gADC_result;
	MOVW R18,R8
;     143   ADC_complete=0;                                   // 
	CLT
	BLD  R2,0
;     144 
;     145   PORTD&=~(1<<5);                                   //    
	CBI  0x12,5
;     146   delay_us(10);
	__DELAY_USB 53
;     147   ADCSRA|=0x40;
	SBI  0x6,6
;     148   while(ADC_complete!=1);
_0x15:
	SBRS R2,0
	RJMP _0x15
;     149   result2=gADC_result;
	MOVW R20,R8
;     150   delta=result2-result1;                            //  -    result2<result1 
	MOVW R30,R20
	SUB  R30,R18
	SBC  R31,R19
	MOVW R16,R30
;     151   if (delta < 0) delta=0;                           //    .  .
	SUBI R16,0
	SBCI R17,0
	BRGE _0x18
	__GETWRN 16,17,0
;     152   ADC_complete=0;
_0x18:
	CLT
	BLD  R2,0
;     153   return delta;                                     //  
	MOVW R30,R16
	RJMP _0x77
;     154 }
;     155 
;     156 void show_sensors (void)                            //    
;     157 {
_show_sensors:
;     158   if(sensor_state & 0b00000001) PORTD|=1<<6; else PORTD&=~(1<<6);
	SBRS R7,0
	RJMP _0x19
	SBI  0x12,6
	RJMP _0x1A
_0x19:
	CBI  0x12,6
;     159   if(sensor_state & 0b00000010) PORTD|=1<<7; else PORTD&=~(1<<7);
_0x1A:
	SBRS R7,1
	RJMP _0x1B
	SBI  0x12,7
	RJMP _0x1C
_0x1B:
	CBI  0x12,7
;     160   if(sensor_state & 0b00000100) PORTB|=1<<0; else PORTB&=~(1<<0);
_0x1C:
	SBRS R7,2
	RJMP _0x1D
	SBI  0x18,0
	RJMP _0x1E
_0x1D:
	CBI  0x18,0
;     161   if(sensor_state & 0b00001000) PORTB|=1<<1; else PORTB&=~(1<<1);
_0x1E:
	SBRS R7,3
	RJMP _0x1F
	SBI  0x18,1
	RJMP _0x20
_0x1F:
	CBI  0x18,1
;     162   if(sensor_state & 0b00010000) PORTB|=1<<2; else PORTB&=~(1<<2);
_0x20:
	SBRS R7,4
	RJMP _0x21
	SBI  0x18,2
	RJMP _0x22
_0x21:
	CBI  0x18,2
;     163   if(sensor_state & 0b00100000) PORTB|=1<<3; else PORTB&=~(1<<3);
_0x22:
	SBRS R7,5
	RJMP _0x23
	SBI  0x18,3
	RJMP _0x24
_0x23:
	CBI  0x18,3
;     164 }
_0x24:
	RET
;     165 
;     166 void check_env(void)                                //   
;     167 {
_check_env:
;     168   unsigned char i, a, b, c;
;     169 
;     170   for(i=0; i<6; i++)                                //    
	RCALL __SAVELOCR4
;	i -> R17
;	a -> R16
;	b -> R19
;	c -> R18
	LDI  R17,LOW(0)
_0x26:
	CPI  R17,6
	BRSH _0x27
;     171   {
;     172     a=poll_sensor(i);                               //  3    
	ST   -Y,R17
	RCALL _poll_sensor
	MOV  R16,R30
;     173     b=poll_sensor(i);                               //        
	ST   -Y,R17
	RCALL _poll_sensor
	MOV  R19,R30
;     174     c=poll_sensor(i);
	ST   -Y,R17
	RCALL _poll_sensor
	MOV  R18,R30
;     175     if(c>=gporog[i]) c=1; else c=0;
	RCALL SUBOPT_0x0
	CP   R18,R30
	BRLO _0x28
	LDI  R18,LOW(1)
	RJMP _0x29
_0x28:
	LDI  R18,LOW(0)
;     176     if(b>=gporog[i]) b=1; else b=0;
_0x29:
	RCALL SUBOPT_0x0
	CP   R19,R30
	BRLO _0x2A
	LDI  R19,LOW(1)
	RJMP _0x2B
_0x2A:
	LDI  R19,LOW(0)
;     177     if(a>=gporog[i]) a=1; else a=0;
_0x2B:
	RCALL SUBOPT_0x0
	CP   R16,R30
	BRLO _0x2C
	LDI  R16,LOW(1)
	RJMP _0x2D
_0x2C:
	LDI  R16,LOW(0)
;     178     c=c+b+a;
_0x2D:
	MOV  R30,R19
	ADD  R30,R18
	ADD  R30,R16
	MOV  R18,R30
;     179     if(c>=2)sensor_state|=1<<i;
	CPI  R18,2
	BRLO _0x2E
	MOV  R30,R17
	LDI  R26,LOW(1)
	RCALL __LSLB12
	OR   R7,R30
;     180      else sensor_state&=~(1<<i);                    //    1     ,   -    
	RJMP _0x2F
_0x2E:
	MOV  R30,R17
	LDI  R26,LOW(1)
	RCALL __LSLB12
	COM  R30
	AND  R7,R30
;     181   };
_0x2F:
	SUBI R17,-1
	RJMP _0x26
_0x27:
;     182   show_sensors();
	RCALL _show_sensors
;     183 }
	RCALL __LOADLOCR4
	ADIW R28,4
	RET
;     184 
;     185 void delay_walk (unsigned int time)                 //   ,  65535,
;     186 {   // ,     
_delay_walk:
;     187   gtime=time;
;	time -> Y+0
	__GETWRS 4,5,0
;     188   while(gtime!=0)
_0x30:
	MOV  R0,R4
	OR   R0,R5
	BREQ _0x32
;     189   {
;     190       check_env();
	RCALL _check_env
;     191       if (sensor_state != sensor_state_last)        //     -  
	CP   R6,R7
	BRNE _0x32
;     192       {                                             //   50  (0,5)
;     193         break;
;     194       };
;     195   };
	RJMP _0x30
_0x32:
;     196 }
	RJMP _0x76
;     197 
;     198 //   
;     199 void f(int t)                                       // 
;     200 {
_f:
;     201  PORTD&=~(1<<1); //PORTD.1=0;
;	t -> Y+0
	CBI  0x12,1
;     202  PORTD|=1<<2;    //PORTD.2=1;
	SBI  0x12,2
;     203  PORTD&=~(1<<3); //PORTD.3=0;
	RCALL SUBOPT_0x1
;     204  PORTD&=~(1<<4); //PORTD.4=0;
;     205  if(t!=0) delay_walk(t);
	BREQ _0x34
	RCALL SUBOPT_0x2
;     206 }
_0x34:
	RJMP _0x76
;     207 
;     208 void b(int t)                                       // 
;     209 {
_b:
;     210  PORTD|=1<<1;    //PORTD.1=1;
;	t -> Y+0
	SBI  0x12,1
;     211  PORTD&=~(1<<2); //PORTD.2=0;
	CBI  0x12,2
;     212  PORTD&=~(1<<3); //PORTD.3=0;
	RCALL SUBOPT_0x1
;     213  PORTD&=~(1<<4); //PORTD.4=0;
;     214  if(t!=0) delay_walk(t);
	BREQ _0x35
	RCALL SUBOPT_0x2
;     215 }
_0x35:
	RJMP _0x76
;     216 
;     217 void fl(int t)                                      //  
;     218 {
_fl:
;     219  PORTD&=~(1<<1); //PORTD.1=0;
;	t -> Y+0
	CBI  0x12,1
;     220  PORTD|=1<<2;    //PORTD.2=1;
	SBI  0x12,2
;     221  PORTD&=~(1<<3); //PORTD.3=0;
	RCALL SUBOPT_0x3
;     222  PORTD|=1<<4;    //PORTD.4=1;
;     223  if(t!=0) delay_walk(t);
	BREQ _0x36
	RCALL SUBOPT_0x2
;     224 }
_0x36:
	RJMP _0x76
;     225 
;     226 void fr(int t)                                      //  
;     227 {
_fr:
;     228  PORTD&=~(1<<1); //PORTD.1=0;
;	t -> Y+0
	CBI  0x12,1
;     229  PORTD|=1<<2;    //PORTD.2=1;
	SBI  0x12,2
;     230  PORTD|=1<<3;    //PORTD.3=1;
	RCALL SUBOPT_0x4
;     231  PORTD&=~(1<<4); //PORTD.4=0;
;     232  if(t!=0) delay_walk(t);
	BREQ _0x37
	RCALL SUBOPT_0x2
;     233 }
_0x37:
	RJMP _0x76
;     234 
;     235 void bl(int t)                                      //  
;     236 {
_bl:
;     237  PORTD|=1<<1;    //PORTD.1=1;
;	t -> Y+0
	SBI  0x12,1
;     238  PORTD&=~(1<<2); //PORTD.2=0;
	CBI  0x12,2
;     239  PORTD&=~(1<<3); //PORTD.3=0;
	RCALL SUBOPT_0x3
;     240  PORTD|=1<<4;    //PORTD.4=1;
;     241  if(t!=0) delay_walk(t);
	BREQ _0x38
	RCALL SUBOPT_0x2
;     242 }
_0x38:
	RJMP _0x76
;     243 
;     244 void br(int t)                                      //  
;     245 {
_br:
;     246  PORTD|=1<<1;    //PORTD.1=1;
;	t -> Y+0
	SBI  0x12,1
;     247  PORTD&=~(1<<2); //PORTD.2=0;
	CBI  0x12,2
;     248  PORTD|=1<<3;    //PORTD.3=1;
	RCALL SUBOPT_0x4
;     249  PORTD&=~(1<<4); //PORTD.4=0;
;     250  if(t!=0) delay_walk(t);
	BREQ _0x39
	RCALL SUBOPT_0x2
;     251 }
_0x39:
	RJMP _0x76
;     252 
;     253 void stop(int t)                                    //
;     254 {
_stop:
;     255  PORTD&=~(1<<1); //PORTD.1=0;
;	t -> Y+0
	CBI  0x12,1
;     256  PORTD&=~(1<<2); //PORTD.2=0;
	CBI  0x12,2
;     257  PORTD&=~(1<<3); //PORTD.3=0;
	RCALL SUBOPT_0x1
;     258  PORTD&=~(1<<4); //PORTD.4=0;
;     259  if(t!=0) delay_walk(t);
	BREQ _0x3A
	RCALL SUBOPT_0x2
;     260 }
_0x3A:
	RJMP _0x76
;     261 
;     262 void led_on(void)                                   // 
;     263 {
_led_on:
;     264  PORTD|=1<<0;    //PORTD.0=1;
	SBI  0x12,0
;     265 }
	RET
;     266 
;     267 void led_off(void)                                  // 
;     268 {
_led_off:
;     269 PORTD&=~(1<<0); //PORTD.0=0;
	CBI  0x12,0
;     270 }
	RET
;     271 
;     272 void go(unsigned char napr)                         //     
;     273 {
_go:
;     274   switch(napr)
;	napr -> Y+0
	LD   R30,Y
;     275   {
;     276      case 0:
	CPI  R30,0
	BRNE _0x3E
;     277         stop(gTimeOfMove);
	RCALL SUBOPT_0x5
	RCALL _stop
;     278         break;
	RJMP _0x3D
;     279      case 1:
_0x3E:
	CPI  R30,LOW(0x1)
	BRNE _0x3F
;     280         f(gTimeOfMove);
	RCALL SUBOPT_0x5
	RCALL _f
;     281         break;
	RJMP _0x3D
;     282      case 2:
_0x3F:
	CPI  R30,LOW(0x2)
	BRNE _0x40
;     283         fr(gTimeOfMove);
	RCALL SUBOPT_0x5
	RCALL _fr
;     284         break;
	RJMP _0x3D
;     285      case 3:
_0x40:
	CPI  R30,LOW(0x3)
	BRNE _0x41
;     286         fl(gTimeOfMove);
	RCALL SUBOPT_0x5
	RCALL _fl
;     287         break;
	RJMP _0x3D
;     288      case 4:
_0x41:
	CPI  R30,LOW(0x4)
	BRNE _0x42
;     289         b(gTimeOfMove);
	RCALL SUBOPT_0x5
	RCALL _b
;     290         break;
	RJMP _0x3D
;     291      case 5:
_0x42:
	CPI  R30,LOW(0x5)
	BRNE _0x43
;     292         br(gTimeOfMove);
	RCALL SUBOPT_0x5
	RCALL _br
;     293         break;
	RJMP _0x3D
;     294      case 6:
_0x43:
	CPI  R30,LOW(0x6)
	BRNE _0x3D
;     295         bl(gTimeOfMove);
	RCALL SUBOPT_0x5
	RCALL _bl
;     296         break;
;     297   };
_0x3D:
;     298 }
	ADIW R28,1
	RET
;     299 
;     300 void disable_way(unsigned char col)                     //,    
;     301 {
_disable_way:
;     302 unsigned char zeroes, notZeroes, i, s, part;
;     303    for (s = 0; s <= 6; s++)                             //    
	RCALL __SAVELOCR6
;	col -> Y+6
;	zeroes -> R17
;	notZeroes -> R16
;	i -> R19
;	s -> R18
;	part -> R21
	LDI  R18,LOW(0)
_0x46:
	CPI  R18,7
	BRSH _0x47
;     304    {
;     305      for (i=0; i<=6; i++)                               //      - ,   
	LDI  R19,LOW(0)
_0x49:
	CPI  R19,7
	BRSH _0x4A
;     306      {
;     307        if (d[s][i]==0 && i!=col) zeroes++;
	RCALL SUBOPT_0x6
	RCALL SUBOPT_0x7
	BRNE _0x4C
	LDD  R30,Y+6
	CP   R30,R19
	BRNE _0x4D
_0x4C:
	RJMP _0x4B
_0x4D:
	SUBI R17,-1
;     308      };
_0x4B:
	SUBI R19,-1
	RJMP _0x49
_0x4A:
;     309      notZeroes = 6 - zeroes;                            //- 
	LDI  R30,LOW(6)
	SUB  R30,R17
	MOV  R16,R30
;     310      part = d[s][col] / notZeroes;                      //,   
	RCALL SUBOPT_0x6
	RCALL SUBOPT_0x8
	RCALL SUBOPT_0x9
	LD   R26,X
	MOV  R30,R16
	RCALL __DIVB21U
	MOV  R21,R30
;     311 
;     312      for (i=0; i<=6; i++)
	LDI  R19,LOW(0)
_0x4F:
	CPI  R19,7
	BRSH _0x50
;     313      {
;     314        if (d[s][i]!=0 && i!=col) d[s][col]+=part;       //
	RCALL SUBOPT_0x6
	RCALL SUBOPT_0x7
	BREQ _0x52
	LDD  R30,Y+6
	CP   R30,R19
	BRNE _0x53
_0x52:
	RJMP _0x51
_0x53:
	RCALL SUBOPT_0x6
	RCALL SUBOPT_0x8
	RCALL SUBOPT_0xA
	MOVW R26,R30
	LD   R30,X
	ADD  R30,R21
	ST   X,R30
;     315      };
_0x51:
	SUBI R19,-1
	RJMP _0x4F
_0x50:
;     316 
;     317      d[s][col]=0;                                       //  
	RCALL SUBOPT_0x6
	RCALL SUBOPT_0x8
	RCALL SUBOPT_0x9
	LDI  R30,LOW(0)
	ST   X,R30
;     318 
;     319    };
	SUBI R18,-1
	RJMP _0x46
_0x47:
;     320 }
_0x77:
	RCALL __LOADLOCR6
	ADIW R28,7
	RET
;     321 
;     322 void enable_way (unsigned char col)                     //    
;     323 {unsigned char s;
_enable_way:
;     324    for (s=0; s<=6; s++)                                 //    
	ST   -Y,R17
;	col -> Y+1
;	s -> R17
	LDI  R17,LOW(0)
_0x55:
	CPI  R17,7
	BRSH _0x56
;     325    {
;     326         if (d[s][col] != etalon[s][col])
	RCALL SUBOPT_0xB
	BREQ _0x57
;     327         {
;     328             if (d[s][col] > etalon[s][col])
	RCALL SUBOPT_0xB
	BRSH _0x58
;     329             {
;     330             d[s][col]-= etalon[s][col] / StepsOfRecover;
	RCALL SUBOPT_0xC
	RCALL SUBOPT_0xD
	MOV  R26,R30
	MOV  R30,R22
	SUB  R30,R26
	__GETW2R 23,24
	ST   X,R30
;     331             };
_0x58:
;     332 
;     333 
;     334             if (d[s][col] < etalon[s][col])
	RCALL SUBOPT_0xC
	RCALL SUBOPT_0x9
	LD   R22,X
	MOVW R30,R0
	SUBI R30,LOW(-_etalon*2)
	SBCI R31,HIGH(-_etalon*2)
	MOVW R26,R30
	LDD  R30,Y+1
	LDI  R31,0
	RCALL SUBOPT_0xA
	LPM  R30,Z
	CP   R22,R30
	BRSH _0x59
;     335             {
;     336             d[s][col]+= etalon[s][col] / StepsOfRecover;
	RCALL SUBOPT_0xC
	RCALL SUBOPT_0xD
	ADD  R30,R22
	__GETW2R 23,24
	ST   X,R30
;     337             };
_0x59:
;     338 
;     339         };
_0x57:
;     340 
;     341    };
	SUBI R17,-1
	RJMP _0x55
_0x56:
;     342 
;     343 }
	LDD  R17,Y+0
_0x76:
	ADIW R28,2
	RET
;     344 
;     345 
;     346 
;     347 
;     348 unsigned char next_move(void)                           //  
;     349 {
_next_move:
;     350   int a, b, c;
;     351 
;     352   do
	RCALL __SAVELOCR6
;	a -> R16,R17
;	b -> R18,R19
;	c -> R20,R21
_0x5B:
;     353   {
;     354         a = rand()/327; 		                //0..99 
	RCALL _rand
	MOVW R26,R30
	LDI  R30,LOW(327)
	LDI  R31,HIGH(327)
	RCALL __DIVW21
	MOVW R16,R30
;     355         c=0;
	__GETWRN 20,21,0
;     356         for (b=0; b<7; b++)                             //  
	__GETWRN 18,19,0
_0x5E:
	__CPWRN 18,19,7
	BRGE _0x5F
;     357         {
;     358             if(a > c && a < (d[now][b]+c) ) break;
	__CPWRR 20,21,16,17
	BRGE _0x61
	RCALL SUBOPT_0xE
	MOV  R26,R30
	MOVW R30,R20
	LDI  R27,0
	RCALL SUBOPT_0xA
	CP   R16,R30
	CPC  R17,R31
	BRLT _0x62
_0x61:
	RJMP _0x60
_0x62:
	RJMP _0x5F
;     359             c=c+d[now][b];
_0x60:
	RCALL SUBOPT_0xE
	LDI  R31,0
	__ADDWRR 20,21,30,31
;     360         };
	__ADDWRN 18,19,1
	RJMP _0x5E
_0x5F:
;     361   }
;     362   while(b==7);                                          //      100,          b==7.   ,        
	LDI  R30,LOW(7)
	LDI  R31,HIGH(7)
	CP   R30,R18
	CPC  R31,R19
	BREQ _0x5B
;     363 
;     364   now = b;
	MOVW R30,R18
	MOV  R11,R30
;     365   return b;
	MOVW R30,R18
	RCALL __LOADLOCR6
	ADIW R28,6
	RET
;     366 };
;     367 
;     368 
;     369 void decision(void)                                     //,        
;     370 {
_decision:
;     371   /* // ,     6 
;     372   if(sensor_state & 0b00000010) disable_way(3); else enable_way(3);   //FL sensor
;     373   if(sensor_state & 0b00000100) disable_way(2); else enable_way(2);   //FR sensor
;     374   if(sensor_state & 0b00001000) disable_way(6); else enable_way(6);   //BL Sensor
;     375   if(sensor_state & 0b00100000) disable_way(5); else enable_way(5);   //BR Sensor
;     376   if(sensor_state & 0b00010000)
;     377   {
;     378     disable_way(4);
;     379     disable_way(5);
;     380     disable_way(6);
;     381 
;     382   } else enable_way(4);   //B sensor
;     383   if(sensor_state & 0b00000001)
;     384   {
;     385     disable_way(1);
;     386     disable_way(2);
;     387     disable_way(3);
;     388 
;     389   } else enable_way(1);   //F sensor
;     390   */
;     391 
;     392   //      2 
;     393   if (sensor_state & 0b00000001 || sensor_state & 0b00000010 || sensor_state & 0b00000100)    //front
	SBRC R7,0
	RJMP _0x64
	SBRC R7,1
	RJMP _0x64
	SBRS R7,2
	RJMP _0x63
_0x64:
;     394   {
;     395     disable_way(1);
	LDI  R30,LOW(1)
	RCALL SUBOPT_0xF
;     396     disable_way(2);
	LDI  R30,LOW(2)
	RCALL SUBOPT_0xF
;     397     disable_way(3);
	LDI  R30,LOW(3)
	RCALL SUBOPT_0xF
;     398   } else
	RJMP _0x66
_0x63:
;     399   {
;     400     enable_way(1);
	LDI  R30,LOW(1)
	RCALL SUBOPT_0x10
;     401     enable_way(2);
	LDI  R30,LOW(2)
	RCALL SUBOPT_0x10
;     402     enable_way(3);
	LDI  R30,LOW(3)
	RCALL SUBOPT_0x10
;     403   };
_0x66:
;     404 
;     405   if (sensor_state & 0b00010000 || sensor_state & 0b00001000 || sensor_state & 0b00100000) //back
	SBRC R7,4
	RJMP _0x68
	SBRC R7,3
	RJMP _0x68
	SBRS R7,5
	RJMP _0x67
_0x68:
;     406   {
;     407     disable_way(4);
	LDI  R30,LOW(4)
	RCALL SUBOPT_0xF
;     408     disable_way(5);
	LDI  R30,LOW(5)
	RCALL SUBOPT_0xF
;     409     disable_way(6);
	LDI  R30,LOW(6)
	RCALL SUBOPT_0xF
;     410   } else
	RJMP _0x6A
_0x67:
;     411   {
;     412     enable_way(4);
	LDI  R30,LOW(4)
	RCALL SUBOPT_0x10
;     413     enable_way(5);
	LDI  R30,LOW(5)
	RCALL SUBOPT_0x10
;     414     enable_way(6);
	LDI  R30,LOW(6)
	RCALL SUBOPT_0x10
;     415   };
_0x6A:
;     416 
;     417   sensor_state_last = sensor_state;
	MOV  R6,R7
;     418 
;     419 }
	RET
;     420 
;     421 
;     422 void start(void)                                        // 
;     423 {
_start:
;     424   while(1)
_0x6B:
;     425   {                                                     // ,   ,       
;     426      check_env();
	RCALL _check_env
;     427      decision();
	RCALL _decision
;     428      h=next_move();
	RCALL _next_move
	MOV  R10,R30
;     429      go(h);
	ST   -Y,R10
	RCALL _go
;     430      led_on();
	RCALL _led_on
;     431      delay(100);
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	RCALL SUBOPT_0x11
;     432      led_off();
;     433 
;     434   };
	RJMP _0x6B
;     435 }
;     436 
;     437 
;     438 void main(void)
;     439 {
_main:
;     440   int i;
;     441  // unsigned int delta;
;     442   //  
;     443   PORTB=0x00;
;	i -> R16,R17
	LDI  R30,LOW(0)
	OUT  0x18,R30
;     444   DDRB=0xFF;
	LDI  R30,LOW(255)
	OUT  0x17,R30
;     445   PORTC=0x00;
	LDI  R30,LOW(0)
	OUT  0x15,R30
;     446   DDRC=0x00;
	OUT  0x14,R30
;     447   PORTD=0x00;
	OUT  0x12,R30
;     448   DDRD=0xFF;
	LDI  R30,LOW(255)
	OUT  0x11,R30
;     449   TCCR0=0x00;
	LDI  R30,LOW(0)
	OUT  0x33,R30
;     450   TCNT0=0x00;
	OUT  0x32,R30
;     451 
;     452   // Timer/Counter 1 initialization
;     453   // Clock source: System Clock
;     454   // Clock value: 15,625 kHz
;     455   // Mode: Normal top=FFFFh
;     456   // OC1A output: Discon.
;     457   // OC1B output: Discon.
;     458   // Noise Canceler: Off
;     459   // Input Capture on Falling Edge
;     460   // Timer 1 Overflow Interrupt: Off
;     461   // Input Capture Interrupt: Off
;     462   // Compare A Match Interrupt: On
;     463   // Compare B Match Interrupt: Off
;     464 
;     465   TCCR1A=0x00;
	OUT  0x2F,R30
;     466   TCCR1B=0x0D;
	LDI  R30,LOW(13)
	OUT  0x2E,R30
;     467   TCNT1H=0x00;
	LDI  R30,LOW(0)
	OUT  0x2D,R30
;     468   TCNT1L=0x00;
	OUT  0x2C,R30
;     469   ICR1H=0x00;
	OUT  0x27,R30
;     470   ICR1L=0x00;
	OUT  0x26,R30
;     471   OCR1AH=0x00;
	OUT  0x2B,R30
;     472   OCR1AL=0x0F;
	LDI  R30,LOW(15)
	OUT  0x2A,R30
;     473   OCR1BH=0x00;
	LDI  R30,LOW(0)
	OUT  0x29,R30
;     474   OCR1BL=0x00;
	OUT  0x28,R30
;     475 
;     476   // Timer/Counter 2 initialization
;     477   // Clock source: System Clock
;     478   // Clock value: Timer 2 Stopped
;     479   // Mode: Normal top=FFh
;     480   // OC2 output: Disconnected
;     481   ASSR=0x00;
	OUT  0x22,R30
;     482   TCCR2=0x00;
	OUT  0x25,R30
;     483   TCNT2=0x00;
	OUT  0x24,R30
;     484   OCR2=0x00;
	OUT  0x23,R30
;     485 
;     486   // External Interrupt(s) initialization
;     487   // INT0: Off
;     488   // INT1: Off
;     489   MCUCR=0x00;
	OUT  0x35,R30
;     490 
;     491   // Timer(s)/Counter(s) Interrupt(s) initialization
;     492   TIMSK=0x10;
	LDI  R30,LOW(16)
	OUT  0x39,R30
;     493 
;     494   // Analog Comparator initialization
;     495   // Analog Comparator: Off
;     496   // Analog Comparator Input Capture by Timer/Counter 1: Off
;     497   ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x8,R30
;     498   SFIOR=0x00;
	LDI  R30,LOW(0)
	OUT  0x30,R30
;     499 
;     500   // ADC initialization
;     501   // ADC Clock frequency: 1000,000 kHz
;     502   // ADC Voltage Reference: AVCC pin
;     503   ADMUX=ADC_VREF_TYPE & 0xff;
	LDI  R30,LOW(64)
	OUT  0x7,R30
;     504   ADCSRA=0x8C;
	LDI  R30,LOW(140)
	OUT  0x6,R30
;     505 
;     506   // Global enable interrupts
;     507   #asm("sei")
	sei
;     508 
;     509 
;     510   while (1)
_0x6E:
;     511   {
;     512       now=1;
	LDI  R30,LOW(1)
	MOV  R11,R30
;     513       for (i=0;i<=5;i++)                                //   ,        
	__GETWRN 16,17,0
_0x72:
	__CPWRN 16,17,6
	BRGE _0x73
;     514       {
;     515         led_on();
	RCALL _led_on
;     516         delay(500);
	LDI  R30,LOW(500)
	LDI  R31,HIGH(500)
	RCALL SUBOPT_0x11
;     517         led_off();
;     518         delay(500);
	LDI  R30,LOW(500)
	LDI  R31,HIGH(500)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay
;     519        };
	__ADDWRN 16,17,1
	RJMP _0x72
_0x73:
;     520 
;     521       start();
	RCALL _start
;     522 
;     523 
;     524   };
	RJMP _0x6E
;     525 }
_0x74:
	RJMP _0x74
;     526 


	.DSEG
__seed_G2:
	.BYTE 0x4

	.CSEG
_rand:
	LDS  R30,__seed_G2
	LDS  R31,__seed_G2+1
	LDS  R22,__seed_G2+2
	LDS  R23,__seed_G2+3
	__GETD2N 0x41C64E6D
	RCALL __MULD12U
	__ADDD1N 30562
	STS  __seed_G2,R30
	STS  __seed_G2+1,R31
	STS  __seed_G2+2,R22
	STS  __seed_G2+3,R23
	mov  r30,r22
	mov  r31,r23
	andi r31,0x7F
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x0:
	MOV  R30,R17
	LDI  R31,0
	SUBI R30,LOW(-_gporog*2)
	SBCI R31,HIGH(-_gporog*2)
	LPM  R30,Z
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x1:
	CBI  0x12,3
	CBI  0x12,4
	LD   R30,Y
	LDD  R31,Y+1
	SBIW R30,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:22 WORDS
SUBOPT_0x2:
	LD   R30,Y
	LDD  R31,Y+1
	ST   -Y,R31
	ST   -Y,R30
	RJMP _delay_walk

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x3:
	CBI  0x12,3
	SBI  0x12,4
	LD   R30,Y
	LDD  R31,Y+1
	SBIW R30,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x4:
	SBI  0x12,3
	CBI  0x12,4
	LD   R30,Y
	LDD  R31,Y+1
	SBIW R30,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:16 WORDS
SUBOPT_0x5:
	LDI  R30,LOW(976)
	LDI  R31,HIGH(976)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:14 WORDS
SUBOPT_0x6:
	LDI  R26,LOW(7)
	MUL  R18,R26
	MOVW R30,R0
	SUBI R30,LOW(-_d)
	SBCI R31,HIGH(-_d)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x7:
	MOVW R26,R30
	CLR  R30
	ADD  R26,R19
	ADC  R27,R30
	LD   R26,X
	CPI  R26,LOW(0x0)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x8:
	MOVW R26,R30
	LDD  R30,Y+6
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x9:
	ADD  R26,R30
	ADC  R27,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0xA:
	ADD  R30,R26
	ADC  R31,R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:20 WORDS
SUBOPT_0xB:
	LDI  R26,LOW(7)
	MUL  R17,R26
	MOVW R30,R0
	SUBI R30,LOW(-_d)
	SBCI R31,HIGH(-_d)
	MOVW R26,R30
	LDD  R30,Y+1
	LDI  R31,0
	RCALL SUBOPT_0x9
	LD   R22,X
	MOVW R30,R0
	SUBI R30,LOW(-_etalon*2)
	SBCI R31,HIGH(-_etalon*2)
	MOVW R26,R30
	LDD  R30,Y+1
	LDI  R31,0
	RCALL SUBOPT_0xA
	LPM  R30,Z
	CP   R30,R22
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:16 WORDS
SUBOPT_0xC:
	LDI  R26,LOW(7)
	MUL  R17,R26
	MOVW R30,R0
	SUBI R30,LOW(-_d)
	SBCI R31,HIGH(-_d)
	MOVW R26,R30
	LDD  R30,Y+1
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0xD:
	RCALL SUBOPT_0xA
	__PUTW1R 23,24
	LD   R22,Z
	MOVW R30,R0
	SUBI R30,LOW(-_etalon*2)
	SBCI R31,HIGH(-_etalon*2)
	MOVW R26,R30
	LDD  R30,Y+1
	LDI  R31,0
	RCALL SUBOPT_0xA
	LPM  R30,Z
	LSR  R30
	LSR  R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0xE:
	MOV  R30,R11
	LDI  R26,LOW(7)
	MUL  R30,R26
	MOVW R30,R0
	SUBI R30,LOW(-_d)
	SBCI R31,HIGH(-_d)
	ADD  R30,R18
	ADC  R31,R19
	LD   R30,Z
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0xF:
	ST   -Y,R30
	RJMP _disable_way

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x10:
	ST   -Y,R30
	RJMP _enable_way

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x11:
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay
	RJMP _led_off

__ANEGW1:
	NEG  R31
	NEG  R30
	SBCI R31,0
	RET

__LSLB12:
	TST  R30
	MOV  R0,R30
	MOV  R30,R26
	BREQ __LSLB12R
__LSLB12L:
	LSL  R30
	DEC  R0
	BRNE __LSLB12L
__LSLB12R:
	RET

__MULD12U:
	MUL  R23,R26
	MOV  R23,R0
	MUL  R22,R27
	ADD  R23,R0
	MUL  R31,R24
	ADD  R23,R0
	MUL  R30,R25
	ADD  R23,R0
	MUL  R22,R26
	MOV  R22,R0
	ADD  R23,R1
	MUL  R31,R27
	ADD  R22,R0
	ADC  R23,R1
	MUL  R30,R24
	ADD  R22,R0
	ADC  R23,R1
	CLR  R24
	MUL  R31,R26
	MOV  R31,R0
	ADD  R22,R1
	ADC  R23,R24
	MUL  R30,R27
	ADD  R31,R0
	ADC  R22,R1
	ADC  R23,R24
	MUL  R30,R26
	MOV  R30,R0
	ADD  R31,R1
	ADC  R22,R24
	ADC  R23,R24
	RET

__DIVB21U:
	CLR  R0
	LDI  R25,8
__DIVB21U1:
	LSL  R26
	ROL  R0
	SUB  R0,R30
	BRCC __DIVB21U2
	ADD  R0,R30
	RJMP __DIVB21U3
__DIVB21U2:
	SBR  R26,1
__DIVB21U3:
	DEC  R25
	BRNE __DIVB21U1
	MOV  R30,R26
	MOV  R26,R0
	RET

__DIVW21U:
	CLR  R0
	CLR  R1
	LDI  R25,16
__DIVW21U1:
	LSL  R26
	ROL  R27
	ROL  R0
	ROL  R1
	SUB  R0,R30
	SBC  R1,R31
	BRCC __DIVW21U2
	ADD  R0,R30
	ADC  R1,R31
	RJMP __DIVW21U3
__DIVW21U2:
	SBR  R26,1
__DIVW21U3:
	DEC  R25
	BRNE __DIVW21U1
	MOVW R30,R26
	MOVW R26,R0
	RET

__DIVW21:
	RCALL __CHKSIGNW
	RCALL __DIVW21U
	BRTC __DIVW211
	RCALL __ANEGW1
__DIVW211:
	RET

__CHKSIGNW:
	CLT
	SBRS R31,7
	RJMP __CHKSW1
	RCALL __ANEGW1
	SET
__CHKSW1:
	SBRS R27,7
	RJMP __CHKSW2
	COM  R26
	COM  R27
	ADIW R26,1
	BLD  R0,0
	INC  R0
	BST  R0,0
__CHKSW2:
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

__LOADLOCR2P:
	LD   R16,Y+
	LD   R17,Y+
	RET

;END OF CODE MARKER
__END_OF_CODE:
