/*****************************************************
This program was produced by the
CodeWizardAVR V1.25.7 beta 5 Professional
Automatic Program Generator
 Copyright 1998-2007 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project :
Version :
Date    : 02.03.2008
Author  : Spiritus Sancti
Company : licrym.org
Comments: CC BY-NC-SA


Chip type           : ATmega8
Program type        : Application
Clock frequency     : 16,000000 MHz
Memory model        : Small
External SRAM size  : 0
Data Stack size     : 256
*****************************************************/

#include <mega8.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
#include <stdlib.h>
#include <delay.h>

#define ADC_VREF_TYPE 0x40

#define gTimeOfMove 976       //     (1 )
#define StepsOfRecover 4      // ,    




unsigned int gtime;
bit ADC_complete;
unsigned char sensor_state, sensor_state_last;     //  ,      
unsigned int gADC_result;
unsigned char now, h;
// 
//
//      1   0   2
//        \ | /
//         [ ]
//        / | \
//       3  4  5

const unsigned char gporog[6]={30, 30, 30, 30, 30, 30};       //    
                                                                    //    30     /-50
                                                                    //const unsigned char gporog[6]={50, 100, 100, 150, 75, 150};
unsigned char d[7][7]={  //  ,  -  ,  - .
//          STO    F   FR    FL    B   BR   BL
/*STO*/     {10,  15,  15,   15,  15,  15,  15},
/*F  */     {17,  23,  25,   25,   0,   0,   0},
/*FR */     {17,  23,  25,   25,   0,   0,   0},
/*FL */     {17,  33,  25,   25,   0,   0,   0},
/*B  */     {25,   0,   0,    0,  25,  25,  25},
/*BR */     {25,   0,   0,    0,  25,  25,  25},
/*BL */     {25,   0,   0,    0,  25,  25,  25}
};

const unsigned char etalon[7][7]={  //  ,     
//          STO    F   FR    FL    B   BR   BL
/*STO*/     {10,  15,  15,   15,  15,  15,  15},
/*F  */     {17,  23,  25,   25,   0,   0,   0},
/*FR */     {17,  23,  25,   25,   0,   0,   0},
/*FL */     {17,  33,  25,   25,   0,   0,   0},
/*B  */     {25,   0,   0,    0,  25,  25,  25},
/*BR */     {25,   0,   0,    0,  25,  25,  25},
/*BL */     {25,   0,   0,    0,  25,  25,  25}
};



interrupt [TIM1_COMPA] void timer1_compa_isr(void)  //     1/976 
{
  if (gtime!=0) --gtime;
}

void delay (unsigned int time)                      //   ,  65535
{
  gtime=time;
  while(gtime!=0){};
}



// ADC interrupt service routine
interrupt [ADC_INT] void adc_isr(void)              //   
{
  unsigned int adc_data;
  // Read the AD conversion result
  adc_data=ADCW;
  gADC_result=adc_data;
  ADC_complete=1;
}

int poll_sensor(unsigned char SensorNumber)         //  
{
  int delta, result1, result2;
  ADMUX&=0b11110000;                                //     
  switch(SensorNumber)                              //  
  {
     case 0:
        ADMUX|=0b00000000;
        break;
     case 1:
        ADMUX|=0b00000001;
        break;
     case 2:
        ADMUX|=0b00000010;
        break;
     case 3:
        ADMUX|=0b00000011;
        break;
     case 4:
        ADMUX|=0b00000100;
        break;
     case 5:
        ADMUX|=0b00000101;
        break;
     default:
        ADMUX|=0b00000000;
        break;
  };
  PORTD|=1<<5;                                      //  5   D
  delay_us(50);                                     // 50    
  ADCSRA|=0x40;                                     //    
  while(ADC_complete!=1);                           //    ,  
  result1=gADC_result;
  ADC_complete=0;                                   // 

  PORTD&=~(1<<5);                                   //    
  delay_us(10);
  ADCSRA|=0x40;
  while(ADC_complete!=1);
  result2=gADC_result;
  delta=result2-result1;                            //  -    result2<result1 
  if (delta < 0) delta=0;                           //    .  .
  ADC_complete=0;
  return delta;                                     //  
}

void show_sensors (void)                            //    
{
  if(sensor_state & 0b00000001) PORTD|=1<<6; else PORTD&=~(1<<6);
  if(sensor_state & 0b00000010) PORTD|=1<<7; else PORTD&=~(1<<7);
  if(sensor_state & 0b00000100) PORTB|=1<<0; else PORTB&=~(1<<0);
  if(sensor_state & 0b00001000) PORTB|=1<<1; else PORTB&=~(1<<1);
  if(sensor_state & 0b00010000) PORTB|=1<<2; else PORTB&=~(1<<2);
  if(sensor_state & 0b00100000) PORTB|=1<<3; else PORTB&=~(1<<3);
}

void check_env(void)                                //   
{
  unsigned char i, a, b, c;

  for(i=0; i<6; i++)                                //    
  {
    a=poll_sensor(i);                               //  3    
    b=poll_sensor(i);                               //        
    c=poll_sensor(i);
    if(c>=gporog[i]) c=1; else c=0;
    if(b>=gporog[i]) b=1; else b=0;
    if(a>=gporog[i]) a=1; else a=0;
    c=c+b+a;
    if(c>=2)sensor_state|=1<<i;
     else sensor_state&=~(1<<i);                    //    1     ,   -    
  };
  show_sensors();
}

void delay_walk (unsigned int time)                 //   ,  65535,
{   // ,     
  gtime=time;
  while(gtime!=0)
  {
      check_env();
      if (sensor_state != sensor_state_last)        //     -  
      {                                             //   50  (0,5)
        break;
      };
  };
}

//   
void f(int t)                                       // 
{
 PORTD&=~(1<<1); //PORTD.1=0;
 PORTD|=1<<2;    //PORTD.2=1;
 PORTD&=~(1<<3); //PORTD.3=0;
 PORTD&=~(1<<4); //PORTD.4=0;
 if(t!=0) delay_walk(t);
}

void b(int t)                                       // 
{
 PORTD|=1<<1;    //PORTD.1=1;
 PORTD&=~(1<<2); //PORTD.2=0;
 PORTD&=~(1<<3); //PORTD.3=0;
 PORTD&=~(1<<4); //PORTD.4=0;
 if(t!=0) delay_walk(t);
}

void fl(int t)                                      //  
{
 PORTD&=~(1<<1); //PORTD.1=0;
 PORTD|=1<<2;    //PORTD.2=1;
 PORTD&=~(1<<3); //PORTD.3=0;
 PORTD|=1<<4;    //PORTD.4=1;
 if(t!=0) delay_walk(t);
}

void fr(int t)                                      //  
{
 PORTD&=~(1<<1); //PORTD.1=0;
 PORTD|=1<<2;    //PORTD.2=1;
 PORTD|=1<<3;    //PORTD.3=1;
 PORTD&=~(1<<4); //PORTD.4=0;
 if(t!=0) delay_walk(t);
}

void bl(int t)                                      //  
{
 PORTD|=1<<1;    //PORTD.1=1;
 PORTD&=~(1<<2); //PORTD.2=0;
 PORTD&=~(1<<3); //PORTD.3=0;
 PORTD|=1<<4;    //PORTD.4=1;
 if(t!=0) delay_walk(t);
}

void br(int t)                                      //  
{
 PORTD|=1<<1;    //PORTD.1=1;
 PORTD&=~(1<<2); //PORTD.2=0;
 PORTD|=1<<3;    //PORTD.3=1;
 PORTD&=~(1<<4); //PORTD.4=0;
 if(t!=0) delay_walk(t);
}

void stop(int t)                                    //
{
 PORTD&=~(1<<1); //PORTD.1=0;
 PORTD&=~(1<<2); //PORTD.2=0;
 PORTD&=~(1<<3); //PORTD.3=0;
 PORTD&=~(1<<4); //PORTD.4=0;
 if(t!=0) delay_walk(t);
}

void led_on(void)                                   // 
{
 PORTD|=1<<0;    //PORTD.0=1;
}

void led_off(void)                                  // 
{
PORTD&=~(1<<0); //PORTD.0=0;
}

void go(unsigned char napr)                         //     
{
  switch(napr)
  {
     case 0:
        stop(gTimeOfMove);
        break;
     case 1:
        f(gTimeOfMove);
        break;
     case 2:
        fr(gTimeOfMove);
        break;
     case 3:
        fl(gTimeOfMove);
        break;
     case 4:
        b(gTimeOfMove);
        break;
     case 5:
        br(gTimeOfMove);
        break;
     case 6:
        bl(gTimeOfMove);
        break;
  };
}

void disable_way(unsigned char col)                     //,    
{
unsigned char zeroes, notZeroes, i, s, part;
   for (s = 0; s <= 6; s++)                             //    
   {
     for (i=0; i<=6; i++)                               //      - ,   
     {
       if (d[s][i]==0 && i!=col) zeroes++;
     };
     notZeroes = 6 - zeroes;                            //- 
     part = d[s][col] / notZeroes;                      //,   

     for (i=0; i<=6; i++)
     {
       if (d[s][i]!=0 && i!=col) d[s][col]+=part;       //
     };

     d[s][col]=0;                                       //  

   };
}

void enable_way (unsigned char col)                     //    
{unsigned char s;
   for (s=0; s<=6; s++)                                 //    
   {
        if (d[s][col] != etalon[s][col])
        {
            if (d[s][col] > etalon[s][col])
            {
            d[s][col]-= etalon[s][col] / StepsOfRecover;
            };


            if (d[s][col] < etalon[s][col])
            {
            d[s][col]+= etalon[s][col] / StepsOfRecover;
            };

        };

   };

}




unsigned char next_move(void)                           //  
{
  int a, b, c;

  do
  {
        a = rand()/327; 		                //0..99 
        c=0;
        for (b=0; b<7; b++)                             //  
        {
            if(a > c && a < (d[now][b]+c) ) break;
            c=c+d[now][b];
        };
  }
  while(b==7);                                          //      100,          b==7.   ,        

  now = b;
  return b;
};


void decision(void)                                     //,        
{
  /* // ,     6 
  if(sensor_state & 0b00000010) disable_way(3); else enable_way(3);   //FL sensor
  if(sensor_state & 0b00000100) disable_way(2); else enable_way(2);   //FR sensor
  if(sensor_state & 0b00001000) disable_way(6); else enable_way(6);   //BL Sensor
  if(sensor_state & 0b00100000) disable_way(5); else enable_way(5);   //BR Sensor
  if(sensor_state & 0b00010000)
  {
    disable_way(4);
    disable_way(5);
    disable_way(6);

  } else enable_way(4);   //B sensor
  if(sensor_state & 0b00000001)
  {
    disable_way(1);
    disable_way(2);
    disable_way(3);

  } else enable_way(1);   //F sensor
  */

  //      2 
  if (sensor_state & 0b00000001 || sensor_state & 0b00000010 || sensor_state & 0b00000100)    //front
  {
    disable_way(1);
    disable_way(2);
    disable_way(3);
  } else
  {
    enable_way(1);
    enable_way(2);
    enable_way(3);
  };

  if (sensor_state & 0b00010000 || sensor_state & 0b00001000 || sensor_state & 0b00100000) //back
  {
    disable_way(4);
    disable_way(5);
    disable_way(6);
  } else
  {
    enable_way(4);
    enable_way(5);
    enable_way(6);
  };

  sensor_state_last = sensor_state;

}


void start(void)                                        // 
{
  while(1)
  {                                                     // ,   ,       
     check_env();
     decision();
     h=next_move();
     go(h);
     led_on();
     delay(100);
     led_off();

  };
}


void main(void)
{
  int i;
 // unsigned int delta;
  //  
  PORTB=0x00;
  DDRB=0xFF;
  PORTC=0x00;
  DDRC=0x00;
  PORTD=0x00;
  DDRD=0xFF;
  TCCR0=0x00;
  TCNT0=0x00;

  // Timer/Counter 1 initialization
  // Clock source: System Clock
  // Clock value: 15,625 kHz
  // Mode: Normal top=FFFFh
  // OC1A output: Discon.
  // OC1B output: Discon.
  // Noise Canceler: Off
  // Input Capture on Falling Edge
  // Timer 1 Overflow Interrupt: Off
  // Input Capture Interrupt: Off
  // Compare A Match Interrupt: On
  // Compare B Match Interrupt: Off

  TCCR1A=0x00;
  TCCR1B=0x0D;
  TCNT1H=0x00;
  TCNT1L=0x00;
  ICR1H=0x00;
  ICR1L=0x00;
  OCR1AH=0x00;
  OCR1AL=0x0F;
  OCR1BH=0x00;
  OCR1BL=0x00;

  // Timer/Counter 2 initialization
  // Clock source: System Clock
  // Clock value: Timer 2 Stopped
  // Mode: Normal top=FFh
  // OC2 output: Disconnected
  ASSR=0x00;
  TCCR2=0x00;
  TCNT2=0x00;
  OCR2=0x00;

  // External Interrupt(s) initialization
  // INT0: Off
  // INT1: Off
  MCUCR=0x00;

  // Timer(s)/Counter(s) Interrupt(s) initialization
  TIMSK=0x10;

  // Analog Comparator initialization
  // Analog Comparator: Off
  // Analog Comparator Input Capture by Timer/Counter 1: Off
  ACSR=0x80;
  SFIOR=0x00;

  // ADC initialization
  // ADC Clock frequency: 1000,000 kHz
  // ADC Voltage Reference: AVCC pin
  ADMUX=ADC_VREF_TYPE & 0xff;
  ADCSRA=0x8C;

  // Global enable interrupts
  #asm("sei")


  while (1)
  {
      now=1;
      for (i=0;i<=5;i++)                                //   ,        
      {
        led_on();
        delay(500);
        led_off();
        delay(500);
       };

      start();


  };
}

